
local oExcel, cText, q, r, i, nRow, f

// Create instances of our variables so we can use 
// the assignment (:=) operator from here on out.
store 0 to oExcel, q, r, i, nRow

set proc to progress.wfm additive
f = new progressForm()
f.mdi = false
f.open()

// Okay, now the program begins
// First generate a query object that will 
// extract the totals by district.
q := new query()
*q.sql := "select District, sum(SaleAmount) as Sales"  + ;
	"from transact group by District"
q.sql := "select * from transact"
q.active := true

// get a reference to the rowset to shorten addressing
r := q.rowset
// make sure we start at the top of the table
r.first()

cText = ""   // initialize our string variable

f.progress1.rangeMax = r.rowCount() * r.fields.size

do while not r.endOfSet
	
    for i = 1 to r.fields.size
		  f.progress1.value ++
        cText += new string(''+trim( '' + r.fields[i].value )) + chr(9)
    endfor
    // get the next record
    r.next()
    cText += chr(13)
enddo

set procedure to clipbord.cc additive
_app.Clip = new TextClipboard() // create our clipboard object

_app.Clip.SetClipboardText( cText )  // place our string

// now we start Excel
oExcel := new oleAutoclient("excel.application")

// create a new workbook
oExcel.workbooks.add()

// since the field and record separators are embedded
// all we need to do is select the top left cell.
// of course you could stick column headings in here, 
// but we won't bother in this example.
oExcel.ActiveSheet.cells( 1,1 ).select()

// now just call Excel's paste method
oExcel.ActiveSheet.paste()

// and size the columns to fit
oExcel.ActiveSheet.Columns.AutoFit()

// now we select A1 to un-select the range
oExcel.ActiveSheet.Range("A1").Select()

f.release()

// and proudly show the result
oExcel.visible = true

